<template>
    <div class="register row justify-content-center">
        <div class="col-md-4 col-12 col-sm-12">
            <div class="card">
                <div class="card-header">Register new user</div>
                <div class="card-body">
                    <form @submit.prevent="register">
                        <div class="form-group row">
                            <label for="email">Name:</label>
                            <input type="text"
                                   v-model="form.name"
                                   class="form-control"
                                   placeholder="Name"
                                   v-bind:class="{ 'is-invalid': errors.name }">

                            <ul class="invalid-feedback" role="alert" v-if="errors.name">
                                <li v-for="(key, value) in errors.name" :key="key">{{ value }}</li>
                            </ul>
                        </div>
                        <div class="form-group row">
                            <label for="email">Email:</label>
                            <input type="email"
                                   v-model="form.email"
                                   class="form-control"
                                   v-bind:class="{ 'is-invalid': errors.email }"
                                   placeholder="Email Address">

                            <ul class="invalid-feedback" role="alert" v-if="errors.email">
                                <li v-for="(key, value) in errors.email" :key="key">{{ value }}</li>
                            </ul>
                        </div>
                        <div class="form-group row">
                            <label for="password">Password:</label>
                            <input type="password"
                                   v-model="form.password"
                                   class="form-control"
                                   placeholder="Password"
                                   autocomplete="off"
                                   v-bind:class="{ 'is-invalid': errors.password }">

                            <ul class="invalid-feedback" role="alert" v-if="errors.password">
                                <li v-for="(key, value) in errors.password" :key="key">{{ value }}</li>
                            </ul>
                        </div>
                        <div class="form-group row">
                            <label for="password_confirmation">Confirm password:</label>
                            <input type="password"
                                   v-model="form.password_confirmation"
                                   class="form-control"
                                   placeholder="Confirm password"
                                   autocomplete="off"
                                   v-bind:class="{ 'is-invalid': errors.password }">
                        </div>
                        <div class="form-group row">
                            <button class="btn btn-primary" type="submit">Register</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
export default {
  name: "register",
  metaInfo: {
    title: "Registration"
  },
  data() {
    return {
      form: {
        name: "",
        email: "",
        password: "",
        password_confirmation: ""
      },
      errors: []
    };
  },
  methods: {
    register() {
      //Post New User Registration to the API
      axios
        .post("/api/v1/auth/register", this.$data.form, {})
        .then(response => {
          this.$store.commit("registerSuccess", response);
          this.$router.push({ path: "/" });
        })
        .catch(error => {
          console.log(error.response);
          this.errors = error.response.data.errors;
        });
    }
  }
};
</script>
